import dom = require("dojo/dom-construct");
import attr = require("dojo/dom-attr");
import { argumentNotEmptyString } from "@implab/core-amd/safe";
import { BuildContextBase } from "./BuildContextBase";

export class HtmlElementContext extends BuildContextBase {
    elementType: string;

    _element: HTMLElement;

    constructor(elementType: string) {
        argumentNotEmptyString(elementType, "elementType");
        super();

        this.elementType = elementType;
    }

    _addChild(child: any): void {
        dom.place(this.getChildDom(child), this._element);
    }

    _setAttrs(attrs: object): void {
        attr.set(this._element, attrs);
    }

    _create(attrs: object, children: any[]) {
        this._element = dom.create(this.elementType, attrs);

        if (children)
            children.forEach(v => this._addChild(v));
    }

    _getDomElement() {
        return this._element;
    }

}
